searchNodes=[{"doc":"Monaco Editor component for Phoenix LiveView. Installation Add :live_monaco_editor dependency: def deps do [ { :live_monaco_editor , &quot;~&gt; 0.1&quot; } ] end Once installed, change your assets/js/app.js file to load the code editor hook in the live socket: import { CodeEditorHook } from &quot;../../deps/live_monaco_editor/priv/static/live_monaco_editor.esm&quot; let Hooks = {} Hooks.CodeEditorHook = CodeEditorHook let liveSocket = new LiveSocket(&quot;/live&quot;, Socket, { hooks: Hooks, params: { _csrf_token: csrfToken } }) And change your assets/css/app.css file to load styling: @import &quot;../../deps/live_monaco_editor/priv/static/live_monaco_editor.min.css&quot;; Usage A new editor using the default options can be created as: &lt;LiveMonacoEditor.code_editor value=&quot;# My Code Editor&quot; /&gt; Or you can customize it: &lt;LiveMonacoEditor.code_editor style=&quot;min-height: 250px; width: 100%;&quot; value={~S{ defmodule Math do def sum_list([head | tail], accumulator) do sum_list(tail, head + accumulator) end def sum_list([], accumulator) do accumulator end end IO.puts Math.sum_list([1, 2, 3], 0) }} opts={ Map.merge( LiveMonacoEditor.default_opts(), %{&quot;language&quot; =&gt; &quot;elixir&quot;} ) } /&gt; Features Set editor options All monaco editor options are supported by passing a map to opts , for example to change the initial language and some other visual options: &lt;LiveMonacoEditor.code_editor value=&quot;&lt;h1&gt;My Code Editor&lt;/h1&gt;&quot; opts={ %{ &quot;language&quot; =&gt; &quot;html&quot;, &quot;fontSize&quot; =&gt; 10, &quot;minimap&quot; =&gt; %{ &quot;autohide&quot; =&gt; true, &quot;showSlider&quot; =&gt; &quot;always&quot; } } } /&gt; Merge with default options The code editor is created with default options to provide a better UX out-of-the-box, which may not suit your needs, but you can keep the defaults and overwrite some options as you wish: &lt;LiveMonacoEditor.code_editor opts={ Map.merge( LiveMonacoEditor.default_opts(), %{&quot;wordWrap&quot; =&gt; &quot;on&quot;} ) } /&gt; Fetching the editor value You can listen to events emitted by the code editor to fetch its current value and send it back to the parent LiveView where the component is used. Firstly, add a event listener: window.addEventListener(&quot;lme:editor_mounted&quot;, (ev) =&gt; { const hook = ev.detail.hook // https://microsoft.github.io/monaco-editor/docs.html#interfaces/editor.IStandaloneCodeEditor.html const editor = ev.detail.editor.standalone_code_editor // push an event to the parent liveview containing the editor current value // when the editor loses focus editor.onDidBlurEditorWidget(() =&gt; { hook.pushEvent(&quot;code-editor-lost-focus&quot;, { value: editor.getValue() }) }) }) Then you can handle that event on the LiveView to save the editor content or perform any sort of operation you need: def handle_event ( &quot;code-editor-lost-focus&quot; , %{ &quot;value&quot; =&gt; value } , socket ) do { :noreply , assign ( socket , :source , value ) } end Multiple editors Set an unique id and path for each one: &lt;LiveMonacoEditor.code_editor id=&quot;html&quot; path=&quot;my_file.html&quot; /&gt; &lt;LiveMonacoEditor.code_editor id=&quot;css&quot; path=&quot;my_file.css&quot; /&gt; Inside forms with phx-change Monaco Editor will create a textarea element that will get pushed back to the server with the path value: &lt;form phx-change=&quot;validate&quot;&gt; &lt;LiveMonacoEditor.code_editor path=&quot;my_file.html&quot; value=&quot;&lt;h1&gt;Title&lt;/h1&gt;&quot; /&gt; &lt;/form&gt; Which you can pattern match to either ignore or process the value: def handle_event ( &quot;validate&quot; , %{ &quot;_target&quot; =&gt; [ &quot;live_monaco_editor&quot; , &quot;my_file.html&quot; ] , &quot;live_monaco_editor&quot; =&gt; %{ &quot;my_file.html&quot; =&gt; content } } , socket ) do # do something with `content` # or just ignore the event { :noreply , socket } end Note that only adding new content into the editor will trigger this event. For example hitting &quot;backspace&quot; won't trigger this event. Change language and value &lt;button phx-click=&quot;create-file&quot;&gt;my_file.html&lt;/button&gt; def handle_event ( &quot;create-file&quot; , _params , socket ) do { :noreply , socket |&gt; LiveMonacoEditor . change_language ( &quot;html&quot; ) |&gt; LiveMonacoEditor . set_value ( &quot;&lt;h1&gt;New File&lt;/h1&gt;&quot; ) } end More operations will be supported in new releases. Styling The component does not depend on any CSS framework but its parent container has to be large enough to be visible. The default style can be changed and/or classes can be applied: &lt;LiveMonacoEditor.code_editor style=&quot;height: 100%; width: 100%; min-height: 1000px; min-width: 600px;&quot; class=&quot;my-2&quot; /&gt; Status Early-stage, you can expect incomplete features and breaking changes. Contributing You can use the file dev.exs which is a self-contained Phoenix application running LiveMonacoEditor. Execute: mix setup iex -S mix dev Visit http://localhost:4002 Acknowledgements Jonatan Kłosko for his amazing work with Livebook Editor","ref":"LiveMonacoEditor.html","title":"LiveMonacoEditor","type":"module"},{"doc":"Change the editor's language. Examples LiveMonacoEditor . change_language ( socket , &quot;markdown&quot; , to : &quot;my_file.md&quot; ) Options :to - the editor's path name that will get the language changed. Defaults to &quot;file&quot;. See https://microsoft.github.io/monaco-editor/docs.html#functions/editor.setModelLanguage.html for more info.","ref":"LiveMonacoEditor.html#change_language/3","title":"LiveMonacoEditor.change_language/3","type":"function"},{"doc":"Renders a monaco editor model . Examples Render a simple editor using default options: &lt; LiveMonacoEditor . code_editor value = &quot;# My Code Editor&quot; / &gt; Or merge with custom options: &lt; LiveMonacoEditor . code_editor opts = { Map . merge ( LiveMonacoEditor . default_opts ( ) , %{ &quot;wordWrap&quot; =&gt; &quot;on&quot; } ) } / &gt; Attributes path ( :string ) - file identifier, pass unique names to render multiple editors. Defaults to &quot;file&quot; . value ( :string ) - initial content. Defaults to &quot;&quot; . opts ( :map ) - options for the monaco editor instance Example %{ &quot;language&quot; =&gt; &quot;markdown&quot; , &quot;fontSize&quot; =&gt; 12 , &quot;wordWrap&quot; =&gt; &quot;on&quot; } See all available options at https://microsoft.github.io/monaco-editor/docs.html#interfaces/editor.IStandaloneEditorConstructionOptions.html Defaults to %{&quot;automaticLayout&quot; =&gt; true, &quot;fontFamily&quot; =&gt; &quot;JetBrains Mono, monospace&quot;, &quot;fontSize&quot; =&gt; 14, &quot;formatOnPaste&quot; =&gt; true, &quot;formatOnType&quot; =&gt; true, &quot;language&quot; =&gt; &quot;markdown&quot;, &quot;minimap&quot; =&gt; %{&quot;enabled&quot; =&gt; false}, &quot;occurrencesHighlight&quot; =&gt; false, &quot;renderLineHighlight&quot; =&gt; &quot;none&quot;, &quot;scrollBeyondLastLine&quot; =&gt; false, &quot;suggestSelection&quot; =&gt; &quot;first&quot;, &quot;tabCompletion&quot; =&gt; &quot;on&quot;, &quot;tabSize&quot; =&gt; 2, &quot;theme&quot; =&gt; &quot;default&quot;} . style ( :string ) - Defaults to &quot;min-height: 100px; width: 100%;&quot; . Global attributes are accepted.","ref":"LiveMonacoEditor.html#code_editor/1","title":"LiveMonacoEditor.code_editor/1","type":"function"},{"doc":"The default Monaco Editor opts passed to &lt;.code_editor&gt;","ref":"LiveMonacoEditor.html#default_opts/0","title":"LiveMonacoEditor.default_opts/0","type":"function"},{"doc":"Change the editor's value (content). Examples LiveMonacoEditor . set_value ( socket , &quot;Enum.all?([1, 2, 3])&quot; , to : &quot;my_script.exs&quot; ) Options :to - the editor's path name that will get the value updated. Defaults to &quot;file&quot;. See https://microsoft.github.io/monaco-editor/docs.html#interfaces/editor.IStandaloneCodeEditor.html#setValue for more info.","ref":"LiveMonacoEditor.html#set_value/3","title":"LiveMonacoEditor.set_value/3","type":"function"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Enhancements Load JetBrains Mono font by default Load OneDark theme by default Bug fixes Remove unnecessary parent &lt;div&gt; element","ref":"changelog.html#0-1-2-2023-06-10","title":"Changelog - 0.1.2 (2023-06-10)","type":"extras"},{"doc":"Enhancements Set default theme vs-dark Bug fixes Only install and load esbuild in :dev env","ref":"changelog.html#0-1-1-2023-06-08","title":"Changelog - 0.1.1 (2023-06-08)","type":"extras"},{"doc":"Enhancements Add &lt;LiveMonacoEditor.code_editor&gt; component","ref":"changelog.html#0-1-0-2023-05-23","title":"Changelog - 0.1.0 (2023-05-23)","type":"extras"}]